part of nabaztag_library;

class NabaztagManager{
  Bunny _bunny;
  bool _ready = false;
  int numberTry=0;
  
  NabaztagManager(String aMacAddress,String anUsername,String aPassword,String anApiUrl){
    _bunny = new Bunny(aMacAddress, anUsername, aPassword, anApiUrl);
    _bunny.setToken().then(_tokenReceived);
  }
  _sendFunctionToBunny(String package,String functionName,Map<String,String> parameters,dynamic callback){
    if(!_ready && numberTry < 5){
      numberTry++;
      print("notReady");
      new Timer(new Duration(seconds: 3),(){
        print("test");
        _sendFunctionToBunny(package, functionName, parameters,callback);
      });
    }
    else if(numberTry>=5){
      numberTry = 0;
    }
    else{
      _trySendFunctionToBunny(package, functionName, parameters,callback);
    }
  }
  _trySendFunctionToBunny(String package,String functionName,Map<String,String> parameters,dynamic callback){
      StringBuffer sb = new StringBuffer("http://ojn.raspberry.pi/ojn_api/");
      sb.write(package);
      sb.write("/");
      sb.write(_bunny.macAddress);
      sb.write("/");
      sb.write(functionName);
      sb.write("?");
      if(parameters.length!=0){
        parameters.forEach((K,V){
          K=K.replaceAll(" ", "%20");
          sb.write(K);
          sb.write("=");
          V=V.replaceAll(" ", "%20");
          sb.write(V);
          sb.write("&");
        });
      }
      sb.write("token=");
      sb.write(_bunny.token);
      print("url sent");
      print(sb.toString());
      http.get(sb.toString()).then(callback);
  }
  
  void _dataReceived(http.Response response){
    print(response.statusCode);
    print("data Received");
    print(response);
    print("body");
    print(response.body);
  }
  
  void sendTextToBunny(String textToSend){
    Map m = new Map();
    m["text"]=textToSend;
    _sendFunctionToBunny("bunny", "tts/say", m,print);
  }

  void _tokenReceived(http.Response response){
    String tmpToken = response.body.split("<")[3].split(">")[1];
    if(tmpToken.compareTo("Access denied")==0){
      print("Access denied");
    }
    else{
      _bunny.token = tmpToken;
      _ready = true;
    }
  }
  List<String> getColorList(){
    List<String> list = new List<String>();
    _sendFunctionToBunny("bunny", "colorbreathing/getColorList", new Map(),(response){
      http.Response r = response;
      print(response);
      String s = r.body.replaceAll("item","|");
      s = s.replaceAll("<", "");
      s = s.replaceAll(">", "");
      s = s.replaceAll("/", "");
      s = s.replaceAll("api", "");
      s = s.replaceAll("list", "");
      list = s.split("|");
    });
    return list;
  }
}